-- =============================================
-- Author		: Rahmat Setiawan
-- Create date	: 2014.06.30
-- Description	: Action for monthly forecast feedback reminder
-- =============================================

/*
OLD JOB:
SELECT PRODUCTION_MONTH, LPOP_TIMING INTO #LPOP_CONFIRM
FROM TB_R_LPOP_CONFIRMATION WHERE CAST(GETDATE() AS DATE) BETWEEN CAST(FEEDBACK_DUE_DATE AS DATE) AND CAST(LAST_REMINDING_DATE AS DATE)

DECLARE @PROD_MONTH VARCHAR(6) = (SELECT PRODUCTION_MONTH FROM #LPOP_CONFIRM),
                  @TIMING VARCHAR(1) = (SELECT LPOP_TIMING FROM #LPOP_CONFIRM)

EXEC SP_LPOPConfirmation_Email @PROD_MONTH, @TIMING, '11005'
*/

CREATE PROCEDURE [dbo].[SP_LPOPConfirmation_Email]
	@PROD_MONTH VARCHAR(6),
	@TIMING VARCHAR(1),
	@FUNCTION_ID VARCHAR(20)
AS
BEGIN
	SET NOCOUNT ON;

    CREATE TABLE #CONTACT_LIST (ROWID int IDENTITY(1,1), USERNAME VARCHAR(20), EMAIL VARCHAR(50), COMPANY_NAME VARCHAR(50), SUPPLIER_CD VARCHAR(6))
	CREATE TABLE #NOTIFICATION_CONTENT (NOTIFICATION_SUBJECT VARCHAR(MAX), NOTIFICATION_CONTENT VARCHAR(MAX))
		
	DECLARE @SQL_REFF VARCHAR(MAX) = '',
			@GROUP_ID BIGINT = (SELECT MAX(GROUP_ID) + 1 FROM TB_R_NOTIFICATION),
			@LOCK_PROCESS INT = (SELECT COUNT(1) FROM TB_T_LOCK WHERE FUNCTION_NO = @FUNCTION_ID AND LOCK_REFF = @PROD_MONTH),
			@CONTENT_ID VARCHAR(2) = (SELECT CASE WHEN @TIMING = 'F' THEN '31' ELSE '34' END),
			@CC_MAIL_LIST VARCHAR(MAX) = '',
			@CONTENT_FIX VARCHAR(MAX),
			@SUBJECT_FIX VARCHAR(MAX),
			@BEGIN_FEEDBACK DATE,
			@END_FEEDBACK DATE,
			@FORECAST_VOL VARCHAR(30)
			
	DECLARE @S_SUPPLIER_CD VARCHAR(6),
			@S_PROD_MONTH VARCHAR(6),
			@S_FEEDBACK_DUE_DATE DATETIME,
			@S_SUPPLIER_PLANT VARCHAR(1),
			@C_EMAIL VARCHAR(50),
			@C_EMAIL_CC VARCHAR(50)
		
	---=== INITIAL STATEMENT
		---=== CREATE CONTACT LIST
		INSERT INTO #CONTACT_LIST
		SELECT '9999.zelfiadi' AS USERNAME, 'zelfiadi@toyota.co.id' AS EMAIL, 'PCD Zel Fiadi' AS COMPANY_NAME, '9999' AS SUPPLIER_CD
		UNION ALL
		SELECT '9999.lian' AS USERNAME, 'lian@toyota.co.id' AS EMAIL, 'PCD Lian' AS COMPANY_NAME, '9999' AS SUPPLIER_CD
		UNION ALL
		SELECT '9999.yuwono' AS USERNAME, 'yuwono.pamungkas@toyota.co.id' AS EMAIL, 'PCD Yuwono Pamungkas' AS COMPANY_NAME, '9999' AS SUPPLIER_CD
		UNION ALL
		SELECT '9999.dwi' AS USERNAME, 'dwi.prasetiyo@toyota.co.id' AS EMAIL, 'PCD Dwi Prasetiyo' AS COMPANY_NAME, '9999' AS SUPPLIER_CD
		UNION ALL
		SELECT '9999.magang1' AS USERNAME, 'pcd.magang1@toyota.co.id' AS EMAIL, 'PCD Iwan' AS COMPANY_NAME, '9999' AS SUPPLIER_CD
		UNION ALL
		SELECT '9999.magang2' AS USERNAME, 'pcd.magang2@toyota.co.id' AS EMAIL, 'PCD Sandy' AS COMPANY_NAME, '9999' AS SUPPLIER_CD
		UNION ALL
		SELECT emp.USERNAME, emp.EMAIL, emp.COMPANY_NAME, a.SUPPLIER_CD
		FROM TB_R_MONTHLY_FORECAST A 
			INNER JOIN  TB_R_VW_EMPLOYEE EMP on a.SUPPLIER_CD=LEFT(EMP.USERNAME,4)
		WHERE emp.EMAIL IS NOT NULL 
				AND emp.COMPANY_NAME IS NOT NULL
				--remarks by alira.agi 2015-07-23
				--AND a.T_FEEDBACK_DT IS NULL 
		GROUP BY emp.EMAIL, emp.USERNAME, emp.COMPANY_NAME, a.SUPPLIER_CD
		---=== END CONTACT LIST
		
		---=== CREATE CC LIST
		DECLARE CC_CURSOR CURSOR FOR
			SELECT EMAIL_ADDRESS FROM dbo.TB_T_EMAIL_RECIPIENT 
				WHERE RECIPIENT_CD = 'cc01'
		
		OPEN CC_CURSOR;
		
		FETCH NEXT FROM CC_CURSOR 
			INTO @C_EMAIL_CC;

		WHILE @@FETCH_STATUS = 0
		BEGIN
			
			IF (@CC_MAIL_LIST <> '')
				SET @CC_MAIL_LIST = @CC_MAIL_LIST + '; '
			
			SET @CC_MAIL_LIST = @CC_MAIL_LIST + @C_EMAIL_CC
		
			FETCH NEXT FROM CC_CURSOR 
				INTO @C_EMAIL_CC;
			
		END
		
		CLOSE CC_CURSOR;
		DEALLOCATE CC_CURSOR;
		
		IF (@CC_MAIL_LIST <> '')
			SET @CC_MAIL_LIST = '@copy_recipients = ''' + @CC_MAIL_LIST + ''','
		---=== END CC LIST
		
		---=== NOTIFICATION INTERVAL
		SET @BEGIN_FEEDBACK = CAST(LEFT(@PROD_MONTH, 4) + '-' + RIGHT(@PROD_MONTH, 2) + '-01' AS DATE)
		SET @END_FEEDBACK = DATEADD(mm, 3, @BEGIN_FEEDBACK)
		SET @FORECAST_VOL = (SELECT DATENAME(MONTH, @BEGIN_FEEDBACK) + ' ' + CAST(YEAR(@BEGIN_FEEDBACK) AS VARCHAR) + ' - ' + 
									DATENAME(MONTH, @END_FEEDBACK) + ' ' + CAST(YEAR(@END_FEEDBACK) AS VARCHAR))
		---=== END NOTIFICATION INTERVAL
	---=== END INITIAL
	
	INSERT INTO #NOTIFICATION_CONTENT
	SELECT NOTIFICATION_SUBJECT, NOTIFICATION_CONTENT
	FROM TB_M_NOTIFICATION_CONTENT
		WHERE FUNCTION_ID = @FUNCTION_ID AND ROLE_ID = @CONTENT_ID AND NOTIFICATION_METHOD = '1'
	
	IF (@TIMING = 'F')
	BEGIN
	
		---=== FIRM			
		DECLARE SUPPLIER_CURSOR CURSOR FOR
			SELECT a.SUPPLIER_CD, a.PRODUCTION_MONTH, b.LAST_REMINDING_DATE, a.SUPPLIER_PLANT
			FROM TB_R_MONTHLY_FORECAST a 
				INNER JOIN dbo.TB_R_LPOP_CONFIRMATION b ON a.PRODUCTION_MONTH = b.PRODUCTION_MONTH		
			WHERE F_FEEDBACK_DT IS NULL AND a.PRODUCTION_MONTH = @PROD_MONTH AND b.LPOP_TIMING = @TIMING
		
		OPEN SUPPLIER_CURSOR;
		
		FETCH NEXT FROM SUPPLIER_CURSOR 
			INTO @S_SUPPLIER_CD, @S_PROD_MONTH, @S_FEEDBACK_DUE_DATE, @S_SUPPLIER_PLANT;

		WHILE @@FETCH_STATUS = 0
		BEGIN
		   
		   ---=== SET SUBJECT & CONTENT
			SET @SUBJECT_FIX = (SELECT NOTIFICATION_SUBJECT FROM #NOTIFICATION_CONTENT)
			SET @SUBJECT_FIX = REPLACE(@SUBJECT_FIX, '@production_month', (SELECT DATENAME(MONTH, CAST(LEFT(@S_PROD_MONTH, 4) + '-' + RIGHT(@S_PROD_MONTH, 2) + '-01' AS DATE)) + ' ' + LEFT(@S_PROD_MONTH, 4)))
			SET @CONTENT_FIX = (SELECT NOTIFICATION_CONTENT FROM #NOTIFICATION_CONTENT)
			SET @CONTENT_FIX = REPLACE(@CONTENT_FIX, '@suppCode', @S_SUPPLIER_CD)
			SET @CONTENT_FIX = REPLACE(@CONTENT_FIX, '@production_month', (SELECT DATENAME(MONTH, CAST(LEFT(@S_PROD_MONTH, 4) + '-' + RIGHT(@S_PROD_MONTH, 2) + '-01' AS DATE)) + ' ' + LEFT(@S_PROD_MONTH, 4)))
			SET @CONTENT_FIX = REPLACE(@CONTENT_FIX, '@date', (SELECT CAST(DAY(@S_FEEDBACK_DUE_DATE) AS VARCHAR) + ' ' +
																		DATENAME(MONTH, @S_FEEDBACK_DUE_DATE) + ' ' +
																		CAST(YEAR(@S_FEEDBACK_DUE_DATE) AS VARCHAR)))
			SET @CONTENT_FIX = REPLACE(@CONTENT_FIX, '@plantcd', @S_SUPPLIER_PLANT)
			SET @CONTENT_FIX = REPLACE(@CONTENT_FIX, '@forecastvol', @FORECAST_VOL)
		   ---===
		   
			---=== GET RECIPIENT AND DELIVERY MAIL
			DECLARE CONTACT_CURSOR CURSOR FOR
				SELECT EMAIL FROM #CONTACT_LIST 
					WHERE SUPPLIER_CD = @S_SUPPLIER_CD
					
			OPEN CONTACT_CURSOR;
		
			FETCH NEXT FROM CONTACT_CURSOR 
				INTO @C_EMAIL;	
				
			WHILE @@FETCH_STATUS = 0
			BEGIN
			
				SET @SQL_REFF = '
							EXEC msdb.dbo.sp_send_dbmail
							@profile_name = ''IPPCS NOTIFICATION'',
							@body = ''' + @CONTENT_FIX + ''',
							@body_format = ''HTML'',
							@recipients = '''+ @C_EMAIL +''',
							' + @CC_MAIL_LIST + '
							@subject = ''' +  @SUBJECT_FIX + ''';
						'
				-- @recipients = '''+  @C_EMAIL + ''',
				EXEC (@SQL_REFF)
				
				FETCH NEXT FROM CONTACT_CURSOR 
					INTO @C_EMAIL;
			   
			END
			
			CLOSE CONTACT_CURSOR;
			DEALLOCATE CONTACT_CURSOR;
			---=== END GET
		   
			FETCH NEXT FROM SUPPLIER_CURSOR 
				INTO @S_SUPPLIER_CD, @S_PROD_MONTH, @S_FEEDBACK_DUE_DATE, @S_SUPPLIER_PLANT;
		   
		END

		CLOSE SUPPLIER_CURSOR;
		DEALLOCATE SUPPLIER_CURSOR;
		---=== END FIRM
	
	END ELSE
	BEGIN
	
		---=== TENTATIVE			
		DECLARE SUPPLIER_CURSOR CURSOR FOR
			SELECT a.SUPPLIER_CD, a.PRODUCTION_MONTH, b.LAST_REMINDING_DATE, a.SUPPLIER_PLANT
			FROM TB_R_MONTHLY_FORECAST a 
				INNER JOIN dbo.TB_R_LPOP_CONFIRMATION b ON a.PRODUCTION_MONTH = b.PRODUCTION_MONTH		
			WHERE T_FEEDBACK_DT IS NULL AND a.PRODUCTION_MONTH = @PROD_MONTH AND b.LPOP_TIMING = @TIMING
		
		OPEN SUPPLIER_CURSOR;
		
		FETCH NEXT FROM SUPPLIER_CURSOR 
			INTO @S_SUPPLIER_CD, @S_PROD_MONTH, @S_FEEDBACK_DUE_DATE, @S_SUPPLIER_PLANT;

		WHILE @@FETCH_STATUS = 0
		BEGIN
		   
		   ---=== SET SUBJECT & CONTENT
			SET @SUBJECT_FIX = (SELECT NOTIFICATION_SUBJECT FROM #NOTIFICATION_CONTENT)
			SET @SUBJECT_FIX = REPLACE(@SUBJECT_FIX, '@production_month', (SELECT DATENAME(MONTH, CAST(LEFT(@S_PROD_MONTH, 4) + '-' + RIGHT(@S_PROD_MONTH, 2) + '-01' AS DATE)) + ' ' + LEFT(@S_PROD_MONTH, 4)))
			SET @CONTENT_FIX = (SELECT NOTIFICATION_CONTENT FROM #NOTIFICATION_CONTENT)
			SET @CONTENT_FIX = REPLACE(@CONTENT_FIX, '@suppCode', @S_SUPPLIER_CD)
			SET @CONTENT_FIX = REPLACE(@CONTENT_FIX, '@production_month', (SELECT DATENAME(MONTH, CAST(LEFT(@S_PROD_MONTH, 4) + '-' + RIGHT(@S_PROD_MONTH, 2) + '-01' AS DATE)) + ' ' + LEFT(@S_PROD_MONTH, 4)))
			SET @CONTENT_FIX = REPLACE(@CONTENT_FIX, '@date', (SELECT CAST(DAY(@S_FEEDBACK_DUE_DATE) AS VARCHAR) + ' ' +
																		DATENAME(MONTH, @S_FEEDBACK_DUE_DATE) + ' ' +
																		CAST(YEAR(@S_FEEDBACK_DUE_DATE) AS VARCHAR)))
			SET @CONTENT_FIX = REPLACE(@CONTENT_FIX, '@plantcd', @S_SUPPLIER_PLANT)
			SET @CONTENT_FIX = REPLACE(@CONTENT_FIX, '@forecastvol', @FORECAST_VOL)
		   ---===
		   
			---=== GET RECIPIENT AND DELIVERY MAIL
			DECLARE CONTACT_CURSOR CURSOR FOR
				SELECT EMAIL FROM #CONTACT_LIST 
					WHERE SUPPLIER_CD = @S_SUPPLIER_CD
					
			OPEN CONTACT_CURSOR;
		
			FETCH NEXT FROM CONTACT_CURSOR 
				INTO @C_EMAIL;	
				
			WHILE @@FETCH_STATUS = 0
			BEGIN
			
				SET @SQL_REFF = '
							EXEC msdb.dbo.sp_send_dbmail
							@profile_name = ''IPPCS NOTIFICATION'',
							@body = ''' + @CONTENT_FIX + ''',
							@body_format = ''HTML'',
							@recipients = '''+ @C_EMAIL +''',
							' + @CC_MAIL_LIST + '
							@subject = ''' +  (SELECT NOTIFICATION_SUBJECT FROM #NOTIFICATION_CONTENT) + ''';
						'
				--@recipients = '''+  @C_EMAIL + ''',
				EXEC (@SQL_REFF)
				
				FETCH NEXT FROM CONTACT_CURSOR 
					INTO @C_EMAIL;
			   
			END
			
			CLOSE CONTACT_CURSOR;
			DEALLOCATE CONTACT_CURSOR;
			---=== END GET
		   
			FETCH NEXT FROM SUPPLIER_CURSOR 
				INTO @S_SUPPLIER_CD, @S_PROD_MONTH, @S_FEEDBACK_DUE_DATE, @S_SUPPLIER_PLANT;
		   
		END

		CLOSE SUPPLIER_CURSOR;
		DEALLOCATE SUPPLIER_CURSOR;			
		---=== END TENTATIVE
	
	END
END

